// Copyright (C) 2006, Ondra Kamenik

// $Id: parser_exception.cpp 795 2006-06-15 07:46:22Z kamenik $

#include "parser_exception.h"

using namespace ogp;

ParserException::ParserException(const char* m, int offset)
	: mes(new char[strlen(m)+1]), off(offset)
{
	strcpy(mes, m);
}

ParserException::ParserException(const string& m, int offset)
	: mes(new char[m.size()+1]), off(offset)
{
	strncpy(mes, m.c_str(), m.size());
	mes[m.size()] = '\0';
}

ParserException::ParserException(const ParserException& m, int plus_offset)
	: mes(NULL)
{
	copy(m);
	off += plus_offset;
}

ParserException::ParserException(const ParserException& e)
	: mes(NULL)
{
	copy(e);
} 

ParserException::~ParserException()
{
	delete [] mes;
}

void ParserException::copy(const ParserException& e)
{
	if (mes)
		delete [] mes;
	mes = new char[strlen(e.mes)+1];
	strcpy(mes, e.mes);
	off = e.off;
}

void ParserException::print(FILE* fd) const
{
	// todo: to be refined
	fprintf(fd, "%s: offset %d\n", mes, off);
}
