// Copyright (C) 2005, Ondra Kamenik

// $Id: exception.h 859 2006-08-04 06:42:00Z tamas $

#ifndef OGU_EXCEPTION_H
#define OGU_EXCEPTION_H

#include <stdio.h>
#include <string.h>

#include <string>

namespace ogu {

	/** A primitive exception. */
	class Exception {
		static const int file_length = 100;
		static const int mes_length = 500;
	protected:
		char file[file_length];
		int line;
		char mes[mes_length];
	public:
		Exception(const char* f, int l, const char* m)
			{
				strncpy(file, f, file_length-1);
				file[file_length-1] = '\0';
				line = l;
				strncpy(mes, m, mes_length);
				mes[mes_length-1] = '\0';
			}
		Exception(const char* f, int l, const std::string& m)
			{
				strncpy(file, f, file_length-1);
				file[file_length-1] = '\0';
				line = l;
				strncpy(mes, m.c_str(), mes_length-1);
				mes[mes_length] = '\0';
			}
		virtual ~Exception() {}
		void print(FILE* fd) const
			{ fprintf(fd, "%s:%d: %s\n", file, line, mes); }
		void print() const
			{ print(stdout); }
		const char* message() const
			{ return mes; }
	};
};

#endif

// Local Variables:
// mode:C++
// End:
